Attribute VB_Name = "basTvTooltTips"
Public Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" _
    (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" _
    (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const GWL_EXSTYLE = -20
Public Const GWL_HINSTANCE = -6
Public Const GWL_HWNDPARENT = -8
Public Const GWL_ID = -12
Public Const GWL_STYLE = -16
Public Const GWL_USERDATA = -21
Public Const GWL_WNDPROC = -4
Public Const DWL_DLGPROC = 4
Public Const DWL_MSGRESULT = 0
Public Const DWL_USER = 8

Public Const TVS_NOTOOLTIPS = &H80

Public Function tvToolTipsOn(tv As TreeView)
    Dim nStyles As Long
    
    With tv
        nStyles = GetWindowLong(.hWnd, GWL_STYLE)
        nStyles = nStyles And (Not TVS_NOTOOLTIPS)
        SetWindowLong .hWnd, GWL_STYLE, nStyles
    End With
    Exit Function
    'Dim style As Long
    
    Style = GetWindowLong(tv.hWnd, GWL_STYLE)
    Call SetWindowLong(tv.hWnd, GWL_STYLE, Style Xor TVS_NOTOOLTIPS)
    
End Function

Public Function tvToolTipsOff(tv As TreeView)
    Dim nStyles As Long
    
    With tv
        nStyles = GetWindowLong(.hWnd, GWL_STYLE)
        nStyles = nStyles Or TVS_NOTOOLTIPS
        SetWindowLong .hWnd, GWL_STYLE, nStyles
    End With
    Exit Function
    'Dim style As Long
    
    Style = GetWindowLong(tv.hWnd, GWL_STYLE)
    Call SetWindowLong(tv.hWnd, GWL_STYLE, Style Xor Not TVS_NOTOOLTIPS)
    
End Function

